"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Loading = exports.NotFound = exports.Error = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactstrap = require("reactstrap");

var _reactRouterDom = require("react-router-dom");

var _utils = require("./utils");

var Error = function Error(_ref) {
  var error = _ref.error,
      className = _ref.className;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _utils.combine_classes)(className, 'error')
  }, /*#__PURE__*/_react.default.createElement("h1", null, "Error"), /*#__PURE__*/_react.default.createElement("p", null, error.message || error.toString()));
};

exports.Error = Error;
var NotFound = (0, _reactRouterDom.withRouter)(function (_ref2) {
  var url = _ref2.url,
      children = _ref2.children,
      location = _ref2.location,
      className = _ref2.className;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _utils.combine_classes)(className, 'not-found')
  }, /*#__PURE__*/_react.default.createElement("h1", null, "Page not found"), /*#__PURE__*/_react.default.createElement("p", null, "The page \"", url || location.pathname, "\" does not exist."), children);
});
exports.NotFound = NotFound;

var Loading = function Loading(_ref3) {
  var className = _ref3.className,
      children = _ref3.children;
  return /*#__PURE__*/_react.default.createElement("div", {
    role: "progressbar",
    className: (0, _utils.combine_classes)(className, 'loading')
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "text-center py-2"
  }, /*#__PURE__*/_react.default.createElement(_reactstrap.Spinner, {
    color: "info"
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "text-center text-muted"
  }, children));
};

exports.Loading = Loading;