"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.get_create_element = get_create_element;
exports.choice_modal = choice_modal;
exports.confirm_modal = confirm_modal;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _reactstrap = require("reactstrap");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var ChoiceModal = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(ChoiceModal, _React$Component);

  var _super = _createSuper(ChoiceModal);

  function ChoiceModal() {
    var _this;

    (0, _classCallCheck2.default)(this, ChoiceModal);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "state", {
      open: true
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "finish", function (answer) {
      _this.setState({
        open: false
      });

      _this.props.resolve(answer);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "render", function () {
      return /*#__PURE__*/_react.default.createElement(_reactstrap.Modal, {
        isOpen: _this.state.open,
        toggle: function toggle() {
          return _this.finish(_this.props.choices[0].answer);
        }
      }, /*#__PURE__*/_react.default.createElement(_reactstrap.ModalBody, null, /*#__PURE__*/_react.default.createElement("div", {
        className: "mb-2"
      }, _this.props.message), /*#__PURE__*/_react.default.createElement("div", {
        className: "text-right"
      }, /*#__PURE__*/_react.default.createElement(_reactstrap.ButtonGroup, null, _this.props.choices.map(function (c, i) {
        return /*#__PURE__*/_react.default.createElement(_reactstrap.Button, {
          key: i,
          size: "sm",
          color: c.colour || 'secondary',
          onClick: function onClick() {
            return _this.finish(c.answer);
          }
        }, c.text);
      })))));
    });
    return _this;
  }

  (0, _createClass2.default)(ChoiceModal, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props !== prevProps) {
        this.setState({
          open: true
        });
      }
    }
  }]);
  return ChoiceModal;
}(_react.default.Component);

function get_create_element(el_id) {
  var el = document.getElementById(el_id);

  if (el) {
    return el;
  } else {
    var new_el = document.createElement('div');
    new_el.id = el_id;
    document.body.appendChild(new_el);
    return document.getElementById(el_id);
  }
}

function choice_modal(message, choices) {
  return new Promise(function (resolve) {
    _reactDom.default.render( /*#__PURE__*/_react.default.createElement(ChoiceModal, {
      resolve: resolve,
      message: message,
      choices: choices
    }), get_create_element('rstb-choice-modal'));
  });
}

function confirm_modal() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      message = _ref.message,
      continue_text = _ref.continue_text,
      continue_colour = _ref.continue_colour,
      cancel_text = _ref.cancel_text,
      cancel_colour = _ref.cancel_colour;

  var choices = [{
    answer: false,
    colour: cancel_colour || null,
    text: cancel_text || 'Cancel'
  }, {
    answer: true,
    colour: continue_colour || 'primary',
    text: continue_text || 'Continue'
  }];
  message = message || 'Are you sure you want to continue?';
  return choice_modal(message, choices);
}