"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ModalForm = exports.StandaloneForm = exports.Form = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactstrap = require("reactstrap");

var _Modal = require("../Modal");

var _Input = require("./Input");

var _context2 = require("../context");

var _freeSolidSvgIcons = require("@fortawesome/free-solid-svg-icons");

var _reactFontawesome = require("@fortawesome/react-fontawesome");

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var DefaultRenderFields = function DefaultRenderFields(_ref) {
  var fields = _ref.fields,
      RenderField = _ref.RenderField;
  return Object.values(fields).map(function (field) {
    return /*#__PURE__*/_react.default.createElement(RenderField, {
      key: field.name,
      field: field
    });
  });
};

var DefaultFormButtons = function DefaultFormButtons(_ref2) {
  var state = _ref2.state,
      form_props = _ref2.form_props,
      submitButtonRef = _ref2.submitButtonRef;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: form_props.form_footer_class || 'text-right'
  }, /*#__PURE__*/_react.default.createElement(_reactstrap.ButtonGroup, null, form_props.onCancel ? /*#__PURE__*/_react.default.createElement(_reactstrap.Button, {
    type: "button",
    color: "secondary",
    disabled: state.disabled || form_props.disabled,
    onClick: function onClick() {
      return form_props.onCancel();
    }
  }, form_props.cancel_label || 'Cancel') : null, /*#__PURE__*/_react.default.createElement(_reactstrap.Button, {
    type: "submit",
    color: "primary",
    disabled: state.disabled || form_props.disabled,
    className: "btn-cog",
    innerRef: submitButtonRef
  }, form_props.save_label || 'Save', /*#__PURE__*/_react.default.createElement(_reactFontawesome.FontAwesomeIcon, {
    icon: _freeSolidSvgIcons.faCog,
    className: "cog-loading fa-fw"
  }))));
};

var _Form = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(_Form, _React$Component);

  var _super = _createSuper(_Form);

  function _Form(props) {
    var _this;

    (0, _classCallCheck2.default)(this, _Form);
    _this = _super.call(this, props);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "form_id", function () {
      return _this.props.id || 'rstb-form';
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "execute", function (data) {
      if (_this.props.execute) {
        return _this.props.execute(data);
      } else if (_this.props.endpoint) {
        if (!window.app || !window.app.requests) {
          throw Error('"window.app.requests" is not set');
        }

        return window.app.requests.post(_this.props.endpoint, data, {
          expected_status: [200, 201, 400, 409, 422, 470]
        });
      } else {
        throw Error('either "execute" or "endpoint" props must be set');
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "submit", /*#__PURE__*/function () {
      var _ref3 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(e) {
        var data, initial, missing, r, errors, _iterator, _step, _e, k, form_error;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!e) {
                  _context.next = 4;
                  break;
                }

                if (!(e.target.id !== _this.form_id())) {
                  _context.next = 3;
                  break;
                }

                return _context.abrupt("return");

              case 3:
                e.preventDefault();

              case 4:
                data = _this.props.submit_data ? _this.props.submit_data(_objectSpread({}, _this.props.form_data)) : _objectSpread({}, _this.props.form_data);

                if (!(_this.props.errors && Object.values(_this.props.errors).some(function (v) {
                  return v;
                }))) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt("return");

              case 7:
                if (!(Object.keys(data).length === 0 && !_this.props.allow_empty)) {
                  _context.next = 10;
                  break;
                }

                _this.setState({
                  form_error: 'No data entered'
                });

                return _context.abrupt("return");

              case 10:
                initial = _this.props.initial || {};
                missing = Object.values(_this.get_fields()).filter(function (f) {
                  return f.required && !initial[f.name] && !data[f.name];
                });

                if (!missing.length) {
                  _context.next = 15;
                  break;
                }

                // required since editors don't use inputs so required won't be caught be the browser
                _this.setState({
                  errors: missing.reduce(function (o, f) {
                    return _objectSpread(_objectSpread({}, o), {}, (0, _defineProperty2.default)({}, f.name, 'Field Required'));
                  }, {})
                });

                return _context.abrupt("return");

              case 15:
                _this.setState({
                  disabled: true,
                  errors: {},
                  form_error: null
                });

                _context.next = 18;
                return _this.execute(data);

              case 18:
                r = _context.sent;

                if (!r) {
                  r = {
                    status: 200
                  };
                }

                if (r.status >= 400) {
                  errors = {};
                  _iterator = _createForOfIteratorHelper(r.data.details || r.data.detail || []);

                  try {
                    for (_iterator.s(); !(_step = _iterator.n()).done;) {
                      _e = _step.value;
                      k = _e.loc[0] === 'body' || _e.loc[0] === 'query' ? _e.loc[1] : _e.loc[0];

                      if (_this.props.fields.hasOwnProperty(k)) {
                        errors[k] = _e.msg;
                      }
                    }
                  } catch (err) {
                    _iterator.e(err);
                  } finally {
                    _iterator.f();
                  }

                  form_error = Object.keys(errors).length ? null : r.data.message || 'Error occurred';

                  _this.setState({
                    disabled: false,
                    errors: errors,
                    form_error: form_error
                  });
                } else {
                  _this.props.afterSubmit && _this.props.afterSubmit(r); // if the form is still visible, it can be made editable again for future use

                  _this.mounted && _this.setState({
                    disabled: false
                  });
                }

              case 21:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref3.apply(this, arguments);
      };
    }());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "setField", function (name, value) {
      if (_this.props.onChange) {
        return _this.props.onChange(_objectSpread(_objectSpread({}, _this.props.form_data), {}, (0, _defineProperty2.default)({}, name, value)));
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "get_fields", function () {
      var fields = {};

      if (_this.props.fields) {
        for (var _i = 0, _Object$entries = Object.entries(_this.props.fields); _i < _Object$entries.length; _i++) {
          var _Object$entries$_i = (0, _slicedToArray2.default)(_Object$entries[_i], 2),
              k = _Object$entries$_i[0],
              v = _Object$entries$_i[1];

          fields[k] = Object.assign({}, v, {
            name: k
          });
        }
      }

      return fields;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "render_field", function (_ref4) {
      var field = _ref4.field,
          optional = _ref4.optional;

      if (!field) {
        if (optional) {
          return null;
        }

        throw TypeError('RenderField: field undefined but "optional" not set, make sure all fields referenced are properly defined.');
      }

      var field_value = _this.props.form_data[field.name];
      var value = field_value === undefined ? (_this.props.initial || {})[field.name] : field_value;
      var name = field.name;

      var onChange = _react.default.useCallback(function (v) {
        _this.setField(name, v);
      }, [name]);

      return /*#__PURE__*/_react.default.createElement(_Input.InputWrapper, (0, _extends2.default)({
        field: field,
        value: value,
        error: _this.errors[name],
        disabled: _this.state.disabled || field.disabled || _this.props.disabled,
        onChange: onChange,
        type_lookup: _this.props.type_lookup,
        onBlur: function onBlur() {
          return _this.props.onBlur && _this.props.onBlur(name);
        }
      }, field.extra || {}));
    });
    _this.state = {
      disabled: false,
      errors: {},
      form_error: null
    };
    _this.errors = {};
    return _this;
  }

  (0, _createClass2.default)(_Form, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.mounted = true;

      if (this.props.submit_initial && this.props.fields) {
        var form_data = {};

        for (var _i2 = 0, _Object$keys = Object.keys(this.props.fields); _i2 < _Object$keys.length; _i2++) {
          var field_name = _Object$keys[_i2];
          var initial = this.props.initial[field_name];

          if (initial) {
            form_data[field_name] = initial;
          }
        }

        this.props.onChange(form_data);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mounted = false;
    }
  }, {
    key: "render",
    value: function render() {
      this.errors = _objectSpread(_objectSpread({}, this.state.errors), this.props.errors || {});
      var RenderFields = this.props.RenderFields || DefaultRenderFields;
      var Buttons = this.props.Buttons || DefaultFormButtons;
      var className = this.props.highlight_required !== false ? 'highlight-required' : null;
      var BeforeButtons = this.props.BeforeButtons || null;
      return /*#__PURE__*/_react.default.createElement(_reactstrap.Form, {
        onSubmit: this.submit,
        className: className,
        id: this.form_id()
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: this.props.form_body_class || 'rstb-form'
      }, this.props.children, /*#__PURE__*/_react.default.createElement("div", {
        className: "form-error text-right"
      }, this.props.form_error || this.state.form_error), /*#__PURE__*/_react.default.createElement(RenderFields, {
        fields: this.get_fields(),
        RenderField: this.render_field
      })), BeforeButtons && /*#__PURE__*/_react.default.createElement(BeforeButtons, {
        form_state: this.state,
        form_props: this.props
      }), /*#__PURE__*/_react.default.createElement(Buttons, {
        state: this.state,
        form_props: this.props,
        setField: this.setField,
        submit: this.submit,
        submitButtonRef: this.props.submitButtonRef
      }));
    }
  }]);
  return _Form;
}(_react.default.Component);

var Form = (0, _context2.WithContext)(_Form);
exports.Form = Form;

var StandaloneForm = function StandaloneForm(props) {
  var _React$useState = _react.default.useState({}),
      _React$useState2 = (0, _slicedToArray2.default)(_React$useState, 2),
      form_data = _React$useState2[0],
      setFormData = _React$useState2[1];

  return /*#__PURE__*/_react.default.createElement(Form, (0, _extends2.default)({}, props, {
    form_data: form_data,
    onChange: setFormData
  }));
};

exports.StandaloneForm = StandaloneForm;
var ModalForm = (0, _Modal.AsModal)(StandaloneForm);
exports.ModalForm = ModalForm;