"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.make_url = make_url;
exports.build_url = build_url;
exports.headers2obj = headers2obj;
exports.request = request;
exports.Requests = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _utils = require("./utils");

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function make_url(path) {
  if (path.match(/^https?:\//)) {
    return path;
  } else {
    if (!path.startsWith('/')) {
      throw Error('path must start with "/"');
    }

    if (process.env.REACT_APP_DOMAIN === 'localhost') {
      return "http://localhost:8000/".concat(path);
    } else if (process.env.REACT_APP_DOMAIN) {
      return "https://".concat(process.env.REACT_APP_DOMAIN).concat(path);
    } else {
      return path;
    }
  }
}

function build_url(url, args) {
  var arg_list = [];

  var add_arg = function add_arg(n, v) {
    return arg_list.push(encodeURIComponent(n) + '=' + encodeURIComponent(v));
  };

  for (var _i = 0, _Object$entries = Object.entries(args); _i < _Object$entries.length; _i++) {
    var _Object$entries$_i = (0, _slicedToArray2.default)(_Object$entries[_i], 2),
        name = _Object$entries$_i[0],
        value = _Object$entries$_i[1];

    if (Array.isArray(value)) {
      var _iterator = _createForOfIteratorHelper(value),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var value_ = _step.value;
          add_arg(name, value_);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    } else if (value !== null && value !== undefined) {
      add_arg(name, value);
    }
  }

  if (arg_list.length > 0) {
    var split = url.includes('?') ? '&' : '?';
    return url + split + arg_list.join('&');
  }

  return url;
}

function headers2obj(r) {
  var h = r.headers;
  var entries = Array.from(h.entries());

  if (entries.length !== 0) {
    return Object.assign.apply(Object, (0, _toConsumableArray2.default)(Array.from(h.entries()).map(function (_ref) {
      var _ref2 = (0, _slicedToArray2.default)(_ref, 2),
          k = _ref2[0],
          v = _ref2[1];

      return (0, _defineProperty2.default)({}, k, v);
    })));
  }
}

function request(_x, _x2, _x3) {
  return _request.apply(this, arguments);
}

function _request() {
  _request = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee7(method, path, config) {
    var make_url_, url, headers, on_error, init, r, e, get_json, data, response_data, message, _e3;

    return _regenerator.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            make_url_ = config.make_url || make_url;
            url = make_url_(path, config);
            config = config || {};

            if (config.args) {
              url = build_url(url, config.args);
            }

            if (Number.isInteger(config.expected_status)) {
              config.expected_status = [config.expected_status];
            } else {
              config.expected_status = config.expected_status || [200, 201];
            }

            headers = config.headers || {};
            headers['Accept'] = headers['Accept'] || 'application/json';

            if (method !== 'GET') {
              headers['Content-Type'] = headers['Content-Type'] || 'application/json';
            }

            on_error = function on_error(e) {
              return config.on_error && config.on_error(e);
            };

            init = {
              method: method,
              headers: headers,
              credentials: 'include'
            };

            if (config.send_data) {
              init.body = JSON.stringify(config.send_data);
            }

            _context7.prev = 11;
            _context7.next = 14;
            return fetch(url, init);

          case 14:
            r = _context7.sent;
            _context7.next = 22;
            break;

          case 17:
            _context7.prev = 17;
            _context7.t0 = _context7["catch"](11);
            // generally TypeError: failed to fetch
            e = (0, _utils.DetailedError)(_context7.t0.message, {
              error: _context7.t0,
              status: 0,
              url: url,
              init: init
            });
            on_error(e);
            throw e;

          case 22:
            get_json = /*#__PURE__*/function () {
              var _ref9 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee6() {
                var body;
                return _regenerator.default.wrap(function _callee6$(_context6) {
                  while (1) {
                    switch (_context6.prev = _context6.next) {
                      case 0:
                        body = null;
                        _context6.prev = 1;
                        _context6.next = 4;
                        return r.text();

                      case 4:
                        body = _context6.sent;
                        return _context6.abrupt("return", JSON.parse(body));

                      case 8:
                        _context6.prev = 8;
                        _context6.t0 = _context6["catch"](1);
                        throw (0, _utils.DetailedError)(_context6.t0.message, {
                          error: _context6.t0,
                          status: r.status,
                          url: url,
                          init: init,
                          body: body,
                          headers: headers2obj(r)
                        });

                      case 11:
                      case "end":
                        return _context6.stop();
                    }
                  }
                }, _callee6, null, [[1, 8]]);
              }));

              return function get_json() {
                return _ref9.apply(this, arguments);
              };
            }();

            if (!config.expected_status.includes(r.status)) {
              _context7.next = 41;
              break;
            }

            if (!config.raw_response) {
              _context7.next = 28;
              break;
            }

            return _context7.abrupt("return", r);

          case 28:
            _context7.prev = 28;
            _context7.next = 31;
            return get_json();

          case 31:
            data = _context7.sent;
            _context7.next = 38;
            break;

          case 34:
            _context7.prev = 34;
            _context7.t1 = _context7["catch"](28);
            on_error(_context7.t1);
            throw _context7.t1;

          case 38:
            return _context7.abrupt("return", {
              data: data,
              status: r.status,
              response: r
            });

          case 39:
            _context7.next = 56;
            break;

          case 41:
            response_data = {};
            _context7.prev = 42;
            _context7.next = 45;
            return get_json();

          case 45:
            response_data = _context7.sent;
            _context7.next = 51;
            break;

          case 48:
            _context7.prev = 48;
            _context7.t2 = _context7["catch"](42);
            // ignore and use normal error
            response_data = _context7.t2.details.body;

          case 51:
            message = "Unexpected response ".concat(r.status, " from \"").concat(url, "\"");

            if (response_data.message) {
              message += ", response message: ".concat(response_data.message);
            }

            _e3 = (0, _utils.DetailedError)(message, {
              status: r.status,
              url: url,
              init: init,
              response_data: response_data,
              headers: headers2obj(r)
            });
            on_error(_e3);
            throw _e3;

          case 56:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7, null, [[11, 17], [28, 34], [42, 48]]);
  }));
  return _request.apply(this, arguments);
}

var Requests = function Requests() {
  var _this = this;

  var _config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  (0, _classCallCheck2.default)(this, Requests);
  (0, _defineProperty2.default)(this, "get", /*#__PURE__*/function () {
    var _ref4 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(path, args) {
      var config,
          c,
          _args = arguments;
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              config = _args.length > 2 && _args[2] !== undefined ? _args[2] : {};
              c = Object.assign({}, _this.config, config, {
                args: args
              });
              _context.next = 4;
              return request('GET', path, c);

            case 4:
              return _context.abrupt("return", _context.sent);

            case 5:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x4, _x5) {
      return _ref4.apply(this, arguments);
    };
  }());
  (0, _defineProperty2.default)(this, "post", /*#__PURE__*/function () {
    var _ref5 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee2(path, send_data) {
      var config,
          c,
          _args2 = arguments;
      return _regenerator.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              config = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : {};
              c = Object.assign({}, _this.config, config, {
                send_data: send_data
              });
              _context2.next = 4;
              return request('POST', path, c);

            case 4:
              return _context2.abrupt("return", _context2.sent);

            case 5:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x6, _x7) {
      return _ref5.apply(this, arguments);
    };
  }());
  (0, _defineProperty2.default)(this, "put", /*#__PURE__*/function () {
    var _ref6 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee3(path, send_data) {
      var config,
          c,
          _args3 = arguments;
      return _regenerator.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              config = _args3.length > 2 && _args3[2] !== undefined ? _args3[2] : {};
              c = Object.assign({}, _this.config, config, {
                send_data: send_data
              });
              _context3.next = 4;
              return request('PUT', path, c);

            case 4:
              return _context3.abrupt("return", _context3.sent);

            case 5:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function (_x8, _x9) {
      return _ref6.apply(this, arguments);
    };
  }());
  (0, _defineProperty2.default)(this, "patch", /*#__PURE__*/function () {
    var _ref7 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee4(path, send_data) {
      var config,
          c,
          _args4 = arguments;
      return _regenerator.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              config = _args4.length > 2 && _args4[2] !== undefined ? _args4[2] : {};
              c = Object.assign({}, _this.config, config, {
                send_data: send_data
              });
              _context4.next = 4;
              return request('PATCH', path, c);

            case 4:
              return _context4.abrupt("return", _context4.sent);

            case 5:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function (_x10, _x11) {
      return _ref7.apply(this, arguments);
    };
  }());
  (0, _defineProperty2.default)(this, "delete", /*#__PURE__*/function () {
    var _ref8 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee5(path, send_data) {
      var config,
          c,
          _args5 = arguments;
      return _regenerator.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              config = _args5.length > 2 && _args5[2] !== undefined ? _args5[2] : {};
              c = Object.assign({}, _this.config, config, {
                send_data: send_data
              });
              _context5.next = 4;
              return request('DELETE', path, c);

            case 4:
              return _context5.abrupt("return", _context5.sent);

            case 5:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));

    return function (_x12, _x13) {
      return _ref8.apply(this, arguments);
    };
  }());
  this.config = _config;
};

exports.Requests = Requests;