"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.load_script = load_script;
exports.combine_classes = exports.DetailedError = exports.on_mobile = exports.get_component_name = exports.as_title = exports.sleep = exports.filter_unique = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _wrapNativeSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapNativeSuper"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

// usage [1, 2, 3, 2, 4].filter(filter_unique) > [1, 2, 3, 4]
var filter_unique = function filter_unique(value, index, array) {
  return array.indexOf(value) === index;
}; // usage await sleet(1000)


exports.filter_unique = filter_unique;

var sleep = function sleep(ms) {
  return new Promise(function (resolve) {
    return setTimeout(resolve, ms);
  });
}; // usage as_title('what_ever') > 'What Ever'


exports.sleep = sleep;

var as_title = function as_title(s) {
  return (s || '').replace(/(_|-)/g, ' ').replace(/(_|\b)\w/g, function (l) {
    return l.toUpperCase();
  });
};

exports.as_title = as_title;

var get_component_name = function get_component_name(Comp) {
  return Comp.displayName || Comp.name || 'Component';
};

exports.get_component_name = get_component_name;
var on_mobile = /mobile|ip(hone|od|ad)|android|blackberry|opera mini/i.test(navigator.userAgent);
exports.on_mobile = on_mobile;

var _DetailedError = /*#__PURE__*/function (_Error) {
  (0, _inherits2.default)(_DetailedError, _Error);

  var _super = _createSuper(_DetailedError);

  function _DetailedError(message, details) {
    var _this;

    (0, _classCallCheck2.default)(this, _DetailedError);
    _this = _super.call(this);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "name", 'DetailedError');
    _this.message = message;
    _this.details = details;
    return _this;
  }

  return _DetailedError;
}( /*#__PURE__*/(0, _wrapNativeSuper2.default)(Error));

var DetailedError = function DetailedError(message, details) {
  return new _DetailedError(message, details);
}; // usage await load_script('https://www.example.com/script.js')


exports.DetailedError = DetailedError;

function load_script(url) {
  return new Promise(function (resolve, reject) {
    if (document.querySelector("script[src=\"".concat(url, "\"]"))) {
      // script already loaded
      resolve();
    } else {
      var script = document.createElement('script');
      script.src = url;

      script.onerror = function (e) {
        return reject(e);
      };

      script.onload = function () {
        return resolve();
      };

      document.body.appendChild(script);
      setTimeout(function () {
        return reject("script \"".concat(url, "\" timed out"));
      }, 8000);
    }
  });
}

var combine_classes = function combine_classes() {
  for (var _len = arguments.length, classes = new Array(_len), _key = 0; _key < _len; _key++) {
    classes[_key] = arguments[_key];
  }

  return classes.filter(function (c) {
    return c;
  }).join(' ');
};

exports.combine_classes = combine_classes;